ExpressionUtils (Groovy 3.0.7)

Package org.apache.groovy.ast.tools

## Class ExpressionUtils

- java.lang.Object
- - org.apache.groovy.ast.tools.ExpressionUtils

-     public final class ExpressionUtils
      extends Object

- - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static boolean` | `isNullConstant​(Expression expr)` |
    `static boolean` | `isNumberOrArrayOfNumber​(ClassNode targetType, boolean recurse)` | Determine if a type is derived from Number (or array thereof).
    `static boolean` | `isSuperExpression​(Expression expression)` |
    `static boolean` | `isThisExpression​(Expression expression)` |
    `static boolean` | `isThisOrSuper​(Expression expression)` |
    `static boolean` | `isTypeOrArrayOfType​(ClassNode targetType, ClassNode type, boolean recurse)` | Determine if a type matches another type (or array thereof).
    `static ConstantExpression` | `transformBinaryConstantExpression​(BinaryExpression be, ClassNode targetType)` | Turns expressions of the form ConstantExpression(40) + ConstantExpression(2) into the simplified ConstantExpression(42) at compile time.
    `static Expression` | `transformInlineConstants​(Expression exp)` | The attribute values of annotations must be primitive, String or Enum constants.
    `static Expression` | `transformInlineConstants​(Expression exp, ClassNode attrType)` | Converts simple expressions of constants into pre-evaluated simple constants.
    `static Expression` | `transformListOfConstants​(ListExpression origList, ClassNode attrType)` | Given a list of constants, transform each item in the list.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### transformBinaryConstantExpression

          public static ConstantExpression transformBinaryConstantExpression​(BinaryExpression be,
                                                                             ClassNode targetType)

      Turns expressions of the form ConstantExpression(40) + ConstantExpression(2) into the simplified ConstantExpression(42) at compile time.
      Parameters:
        `be` - the binary expression
        `targetType` - the type of the result
      Returns:
        the transformed expression or the original if no transformation was performed

    - #### isTypeOrArrayOfType

          public static boolean isTypeOrArrayOfType​(ClassNode targetType,
                                                    ClassNode type,
                                                    boolean recurse)

      Determine if a type matches another type (or array thereof).
      Parameters:
        `targetType` - the candidate type
        `type` - the type we are checking against
        `recurse` - true if we can have multi-dimension arrays; should be false for annotation member types
      Returns:
        true if the type equals the targetType or array thereof

    - #### isNumberOrArrayOfNumber

          public static boolean isNumberOrArrayOfNumber​(ClassNode targetType,
                                                        boolean recurse)

      Determine if a type is derived from Number (or array thereof).
      Parameters:
        `targetType` - the candidate type
        `recurse` - true if we can have multi-dimension arrays; should be false for annotation member types
      Returns:
        true if the type equals the targetType or array thereof

    - #### transformInlineConstants

          public static Expression transformInlineConstants​(Expression exp,
                                                            ClassNode attrType)

      Converts simple expressions of constants into pre-evaluated simple constants. Handles:
      - Property expressions - referencing constants
      - Simple binary expressions - String concatenation and numeric +, -, /, *
      - List expressions - list of constants
      - Variable expressions - referencing constants
      Parameters:
        `exp` - the original expression
        `attrType` - the type that the final constant should be
      Returns:
        the transformed type or the original if no transformation was possible

    - #### transformListOfConstants

          public static Expression transformListOfConstants​(ListExpression origList,
                                                            ClassNode attrType)

      Given a list of constants, transform each item in the list.
      Parameters:
        `origList` - the list to transform
        `attrType` - the target type
      Returns:
        the transformed list or the original if nothing was changed

    - #### transformInlineConstants

          public static Expression transformInlineConstants​(Expression exp)

      The attribute values of annotations must be primitive, String or Enum constants. In various places, such constants can be seen during type resolution but won't be readily accessible in later phases, e.g. they might be embedded into constructor code. This method transforms constants that would appear in annotations early so they aren't lost. Subsequent processing determines whether they are valid, this method simply retains the constant value as a constant expression.
      Parameters:
        `exp` - the original expression
      Returns:
        the converted expression

    - #### isThisExpression

          public static boolean isThisExpression​(Expression expression)

    - #### isSuperExpression

          public static boolean isSuperExpression​(Expression expression)

    - #### isThisOrSuper

          public static boolean isThisOrSuper​(Expression expression)

    - #### isNullConstant

          public static boolean isNullConstant​(Expression expr)